SystemOrganization addCategory: #SeasideGallery!
SystemOrganization addCategory: #'SeasideGallery-views'!
SystemOrganization addCategory: #'SeasideGallery-model'!

WAFileLibrary subclass: #SgFilePool
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SeasideGallery-views'!

!SgFilePool methodsFor: 'uploaded' stamp: 'HK 10/28/2010 14:30:30.173'!
reset

	self filenames do: [ :each |
		self removeFile: each
		]! !

!SgFilePool methodsFor: 'uploaded' stamp: 'HK 11/1/2010 10:46:07.864'!
styleCss
	^ '.loginLabel {
	display: block;
	width: 200px;
	}'! !

WASession subclass: #SgSession
	instanceVariableNames: 'user'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SeasideGallery-model'!

!SgSession methodsFor: 'accessing' stamp: 'HK 11/1/2010 10:13:40.406'!
hasUser

	^ self user notNil! !

!SgSession methodsFor: 'accessing' stamp: 'HK 11/1/2010 10:13:05.014'!
login: aUser

	self user = aUser! !

!SgSession methodsFor: 'accessing' stamp: 'HK 11/1/2010 10:13:17.406'!
logout

	self user = nil! !

!SgSession methodsFor: 'accessing' stamp: 'HK 11/1/2010 10:12:21.321'!
user
	^ user! !

!SgSession methodsFor: 'accessing' stamp: 'HK 11/1/2010 10:12:21.331'!
user: anObject
	user := anObject! !

SDActiveRecord subclass: #SgGallery
	instanceVariableNames: 'title owner isPublic created pictures'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SeasideGallery-model'!

!SgGallery methodsFor: 'as yet unclassified' stamp: 'hauke 10/28/2010 08:15'!
initialize

	super initialize.! !

!SgGallery methodsFor: 'as yet unclassified' stamp: 'hauke 10/28/2010 08:16'!
size! !

SDActiveRecord subclass: #SgPicture
	instanceVariableNames: 'title fileName thumbnail'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SeasideGallery-model'!

!SgPicture class methodsFor: 'as yet unclassified' stamp: 'hauke 10/28/2010 12:14'!
thumbnailSize

	^ 100! !

!SgPicture methodsFor: 'as yet unclassified' stamp: 'hauke 10/28/2010 12:13'!
createThumbnail! !

!SgPicture methodsFor: 'as yet unclassified' stamp: 'hauke 10/28/2010 13:12'!
fileName
	^ fileName! !

!SgPicture methodsFor: 'as yet unclassified' stamp: 'hauke 10/28/2010 12:13'!
fileName: anObject
	fileName := anObject! !

!SgPicture methodsFor: 'as yet unclassified' stamp: 'hauke 10/28/2010 12:12'!
title: aString
	title := aString! !

SDActiveRecord subclass: #SgUser
	instanceVariableNames: 'userName passwordHash'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SeasideGallery-model'!

!SgUser methodsFor: 'accessing' stamp: 'HK 11/1/2010 10:50:53.06'!
passwordHash
	^ passwordHash! !

!SgUser methodsFor: 'accessing' stamp: 'HK 11/1/2010 10:50:53.068'!
passwordHash: anObject
	passwordHash := anObject! !

!SgUser methodsFor: 'accessing' stamp: 'HK 11/1/2010 10:50:53.044'!
userName
	^ userName! !

!SgUser methodsFor: 'accessing' stamp: 'HK 11/1/2010 10:50:53.054'!
userName: anObject
	userName := anObject! !

WAComponent subclass: #SgLoginComponent
	instanceVariableNames: 'userName password'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SeasideGallery-views'!

!SgLoginComponent methodsFor: 'as yet unclassified' stamp: 'HK 11/1/2010 10:16:18.689'!
initialize

	super initialize! !

!SgLoginComponent methodsFor: 'accessing' stamp: 'HK 11/1/2010 10:19:29.322'!
password
	^ password! !

!SgLoginComponent methodsFor: 'accessing' stamp: 'HK 11/1/2010 10:19:29.334'!
password: anObject
	password := anObject! !

!SgLoginComponent methodsFor: 'as yet unclassified' stamp: 'HK 11/1/2010 10:28:44.673'!
renderContentOn: html

	html form: [
		self
			renderHeadingOn: html;
			renderUserNameOn: html;
			renderPasswordInputOn: html;
			renderSubmitButtonOn: html
		]! !

!SgLoginComponent methodsFor: 'as yet unclassified' stamp: 'HK 11/1/2010 10:24:13.242'!
renderHeadingOn: html

	html heading: 'Login'! !

!SgLoginComponent methodsFor: 'as yet unclassified' stamp: 'HK 11/1/2010 10:43:27.651'!
renderPasswordInputOn: html

	html div with:
		[ html span class: 'loginLabel'; with: 'User name'.
		html span with:
			[ html passwordInput on: #password of: self ]].! !

!SgLoginComponent methodsFor: 'as yet unclassified' stamp: 'HK 11/1/2010 10:48:56.598'!
renderSubmitButtonOn: html

	html submitButton
		with: 'Login';
		callback: [ self validateLogin ].! !

!SgLoginComponent methodsFor: 'as yet unclassified' stamp: 'HK 11/1/2010 10:44:04.825'!
renderUserNameOn: html

	html div with:
		[ html span class: 'loginLabel'; with: 'Password'.
		html span with:
			[ html textInput on: #userName of: self ]].! !

!SgLoginComponent methodsFor: 'accessing' stamp: 'HK 11/1/2010 10:28:28.571'!
userName
	^ userName! !

!SgLoginComponent methodsFor: 'accessing' stamp: 'HK 11/1/2010 10:28:28.579'!
userName: anObject
	userName := anObject! !

!SgLoginComponent methodsFor: 'as yet unclassified' stamp: 'HK 11/1/2010 10:49:20.238'!
validateLogin

	SgUser findAll! !

WAComponent subclass: #SgMetaEditor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SeasideGallery-views'!

!SgMetaEditor methodsFor: 'as yet unclassified' stamp: 'hauke 10/28/2010 12:07'!
renderContentOn: html

	html text: 'Hallo'! !

WAComponent subclass: #SgRoot
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SeasideGallery-views'!

!SgRoot class methodsFor: 'as yet unclassified' stamp: 'hauke 10/28/2010 07:24'!
appName

	^ 'Seaside Gallery'! !

!SgRoot class methodsFor: 'as yet unclassified' stamp: 'hauke 10/28/2010 07:19'!
canBeRoot

	^ true! !

!SgRoot class methodsFor: 'as yet unclassified' stamp: 'HK 11/1/2010 10:15:14.418'!
setup

	| application |
	super initialize.
	application := WAAdmin register: self asApplicationAt: 'gallery'.
	application
		preferenceAt: #sessionClass put: SgSession;
		addLibrary: JQDeploymentLibrary;
		addLibrary: JQUiDeploymentLibrary! !

!SgRoot class methodsFor: 'as yet unclassified' stamp: 'hauke 10/28/2010 11:22'!
styleSheet

	^ SgFilePool / #styleCss! !

!SgRoot methodsFor: 'as yet unclassified' stamp: 'hauke 10/28/2010 11:25'!
children

	^ Array new! !

!SgRoot methodsFor: 'as yet unclassified' stamp: 'hauke 10/28/2010 11:24'!
initialize

	super initialize! !

!SgRoot methodsFor: 'as yet unclassified' stamp: 'HK 10/28/2010 15:35:09.964'!
removeData

	SgFilePool new reset.
	SgPicture findAll do: [ :each | each delete ].
	SgGallery findAll do: [ :each | each delete ].! !

!SgRoot methodsFor: 'as yet unclassified' stamp: 'HK 11/1/2010 10:29:59.733'!
renderContentOn: html

	self renderLoginOn: html! !

!SgRoot methodsFor: 'as yet unclassified' stamp: 'HK 10/28/2010 15:28:38.801'!
renderFilesOn: html

	SgPicture findAll do: [ :each |
		html div with: [
			html paragraph: each fileName.
			html image url: (SgFilePool new urlForFile: each fileName)
			]
		]! !

!SgRoot methodsFor: 'as yet unclassified' stamp: 'hauke 10/28/2010 11:28'!
renderHeadingOn: html

	html heading level: 1; with: 'Seaside Gallery'! !

!SgRoot methodsFor: 'as yet unclassified' stamp: 'HK 11/1/2010 10:30:31.854'!
renderLoginOn: html

	html div with: (SgLoginComponent new)! !

!SgRoot methodsFor: 'as yet unclassified' stamp: 'hauke 10/28/2010 12:09'!
renderPlaygroundOn: html

	html anchor callback: [
		self call: (SgMetaEditor new)
		]; with: 'Edit'! !

!SgRoot methodsFor: 'as yet unclassified' stamp: 'hauke 10/28/2010 11:28'!
renderUploaderOn: html

	html div with: (SgUploader new)! !

!SgRoot methodsFor: 'as yet unclassified' stamp: 'HK 10/28/2010 14:51:44.249'!
updateRoot: anHtmlRoot
 
	super updateRoot: anHtmlRoot.
	anHtmlRoot title: self class appName.
	anHtmlRoot stylesheet url: self class styleSheet! !

WAComponent subclass: #SgUploader
	instanceVariableNames: 'filePool'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SeasideGallery-views'!

!SgUploader class methodsFor: 'as yet unclassified' stamp: 'HK 10/28/2010 14:41:18.118'!
supportedFileTypes

	^ Array
		with: 'image/gif'
		with: 'image/png'
		with: 'image/jpeg'! !

!SgUploader methodsFor: 'as yet unclassified' stamp: 'hauke 10/28/2010 11:43'!
filePool

	^ filePool! !

!SgUploader methodsFor: 'as yet unclassified' stamp: 'hauke 10/28/2010 11:43'!
filePool: aLibrary

	filePool := aLibrary! !

!SgUploader methodsFor: 'as yet unclassified' stamp: 'HK 10/28/2010 14:40:21.575'!
fileTypeIsSupportedFor: aFile


	^ self class supportedFileTypes includes: (aFile contentType greaseString)
	! !

!SgUploader methodsFor: 'as yet unclassified' stamp: 'hauke 10/28/2010 11:49'!
initialize

	super initialize.
	self filePool: (SgFilePool new)! !

!SgUploader methodsFor: 'as yet unclassified' stamp: 'hauke 10/28/2010 11:50'!
renderContentOn: html

	self renderFormOn: html! !

!SgUploader methodsFor: 'as yet unclassified' stamp: 'HK 10/28/2010 15:50:27.31'!
renderFormOn: html

	html form multipart; with: [
		html fileUpload callback: [ :newFile |
			self uploadFile: newFile.
			].
		html submitButton: 'Upload'
		]! !

!SgUploader methodsFor: 'as yet unclassified' stamp: 'HK 10/28/2010 15:37:44.08'!
uploadFile: aFile

	| uploadedPicture |
	
	(self fileTypeIsSupportedFor: aFile) ifTrue: [
		self filePool addFile: aFile.
		uploadedPicture := SgPicture new
			title: aFile fileName;
			fileName: aFile fileName.
		uploadedPicture save.
		
		]! !
